unit Rechnen;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Math, StdCtrls;

type
  TForm1 = class(TForm)
    PBox: TPaintBox;
    TafelButton: TButton;
    GroupBox1: TGroupBox;
    NSCroll: TScrollBar;
    NLbl: TLabel;
    TafelSaveDialog: TSaveDialog;
    procedure PBoxPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PBoxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure NSCrollChange(Sender: TObject);
    procedure TafelButtonClick(Sender: TObject);
  private
    { Private declarations }
    mx, my     : double;   // normierte Eingabewerte
    er, ew     : double;   // Ergebniswerte
    winkelwert : double;
    mdrauf     : boolean;

    procedure Maus(X, Y: integer);
    function Rechne ( aX, aY : double): double;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.PBoxPaint(Sender: TObject);
var
 x,y : integer;
 xx,yy : integer;
 R : TRect;
 S : String;
 Q : double;

begin
  with PBox.Canvas do
  begin
    Brush.Color:= clWhite;
    FillRect(PBox.ClientRect);
    Pen.Color:= clRed;
    x:= PBox.ClientWidth div 2;
    y:= PBox.ClientHeight div 2;
    R.Left  := x div 2;
    R.Top   := y div 2;
    R.Right := R.Left * 3;
    R.Bottom:= R.Top * 3;
    Ellipse(R);

    MoveTo(0,y); LineTo(PBox.ClientWidth-1,y);
    MoveTo(x,0); LineTo(x,PBox.ClientHeight-1);

    if (mx<>0) or (my<>0)
    then
    begin
      Font.Size:= 12;
      xx:= round(mx*x) div 2;
      yy:= round(my*y) div 2;
      Pen.Color:= clBlue;
      MoveTo(x,y);
      LineTo(x+xx,y-yy);
      Str(mx:2:6,S);
      S:= 'X = ' + S;
      TextOut(10, 10, S);

      Str(my:2:6,S);
      S:= 'Y = ' + S;
      TextOut(10, 30, S);

      Str(er:2:16,S);
      S:= 'Lnge = ' + S;
      TextOut(10, 50, S);

      Str(WinkelWert:3:16,S);
      S:= 'Winkel= ' + S;
      TextOut(10, 70, S);

    end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   mx:= 0;
   my:= 0;
   mdrauf:= false;
   er:= 0;
   ew:= 0;

end;


procedure TForm1.Maus(X, Y: integer);
var
  i, tx, ty : integer;
  d : double;
begin
  i:= PBox.ClientWidth div 2;
  tx:= X - i;
  d:= i div 2;
  mx:= tx / d;

  i:= PBox.ClientHeight div 2;
  ty:= i - Y;
  d:= i div 2;
  my:= ty / d;
  WinkelWert:= Rechne(mx, my);
  PBox.Repaint;
end;

procedure TForm1.PBoxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  mdrauf:= true;
  Maus(X,Y);
end;

procedure TForm1.PBoxMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 if mdrauf then Maus(X,Y);
end;

procedure TForm1.PBoxMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  mdrauf:= false;;
end;


{ Berechnung von Zeigerlnge und Winkel aus x und y  }
function TForm1.Rechne( aX, aY : double): double;
var
 x, y, z      : double;
 tmpx, tmpy   : double;
 delta, VZ, w : double;
 n, ne        : integer;

begin
  ne:= NScroll.Position;
  x:= aX;
  y:= aY;
  z:= 0.0;
  w:= 0.0;       // default: x>0 und y>0 = 0. Quadrant
  if (mx<=0) and (my>0)
  then
  begin     // 1. Quadrant = oben links
    w:= 1.0;
    y:= -mx;
    x:= my;
  end;

  if (mx<=0) and (my<=0)
  then
  begin    // 2. Quadrant = unten links
    w:= 2.0;
    x:= -mx;
    y:= -my;
  end;

  if (mx>0) and (my<0)
  then
  begin   // 3. Quadrant
    w:= 3.0;
    y:= mx;
    x:= -my;
  end;

  n:= 1;
  delta:= 1.0;

  {  der eigentliche CORDIC }
  repeat
    { wichtig: alle Stellen rechnen,
      dafr aber mit wechselndem Vorzeichen
      je nach Ablage von der Abszisse
    }
    if (y < 0) then VZ:= 1 else VZ:= -1;
    tmpx:= x - VZ * delta * y;
    tmpy:= y + VZ * delta * x;
    x:= tmpx;
    y:= tmpy;
    z:= z - VZ * arctan(delta);
    delta:= delta / 2;
    inc(n);
  until n > ne;

  z:= z * 2 / PI;
  ew:= y;
  er:= x * 0.607252935;
  result:= 90 * (z + w + 0.386589225 * y);
end;


procedure TForm1.NSCrollChange(Sender: TObject);
begin
  NLbl.Caption:= IntToStr(NScroll.Position);
  WinkelWert:= Rechne(mx, my);
  PBox.Repaint;
end;

procedure TForm1.TafelButtonClick(Sender: TObject);
var
  i, j : integer;
  f : double;
  d : double;
  T : Textfile;
begin
  if not TafelSaveDialog.Execute then exit;

  AssignFile(T,TafelSaveDialog.FileName);
  rewrite(T);
  for j:= 5 to 24 do
  begin
    NSCroll.Position:= j;
    writeln(T, 'gerechnete CORDIC Zyklen = ', j);
    for i:= 0 to 359 do
    begin
      f:= i;
      f:= f * PI / 180.0;
      mx:= cos(f);
      my:= sin(f);
      WinkelWert:= Rechne(mx, my);
      d:= WinkelWert - i;
      writeln(T, 'Grad: ', i:3, '; Diff: ', d:19:16, '; ', '; Lnge: ', er:19:16);
    end;
  end;
  closefile(T);
end;

end.
